#!/bin/python
#-*- coding: utf-8 -*-

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

import os
import subprocess
from lib_result import *

def get_cpu_nums():
    try:
        num = 0
        cpuinfos = subprocess.check_output( ['lscpu']).split('\n')
        for cpuinfo in cpuinfos:
            if (cpuinfo.startswith('CPU(s):') or cpuinfo.startswith('CPU:')) and cpuinfo.split()[1].isdigit():
                num = int(cpuinfo.split()[1])
                break
        return Result( None, num)
    except Exception as e:
        return Result( 'Error:' + str(e), None)

def get_mem_capacity():
    try:
        mem = 0
        mem_infos = subprocess.check_output( ['dmidecode', '-t', 'memory']).split('\n')
        for mem_info in mem_infos:
            if mem_info.startswith("\tSize") and mem_info.endswith("MB") and mem_info.split()[1].isdigit():
                mem += int(mem_info.split()[1])
                continue
        return Result( None, mem)
    except Exception as e:
        return Result( 'Error:' + str(e), None)

def get_mem_capacity2():
    try:
        mem = 0
        max_mem_address_num = 0
        last_mem_dir = mem_dir = 0
        mem_dirs = os.listdir( "/sys/firmware/memmap")
        for mem_dir in mem_dirs:
            if int( mem_dir) > int( last_mem_dir):
                last_mem_dir = mem_dir
        last_mem_absolute_dir = os.path.join( "/sys/firmware/memmap", last_mem_dir)
        last_mem_absolute_file_path = os.path.join( last_mem_absolute_dir, "end")
        max_mem_address = open( last_mem_absolute_file_path, "r").read()
        # print max_mem_address
        if max_mem_address.startswith("0x"):
            max_mem_address_num = int(max_mem_address, 16)
        else:
            max_mem_address_num = int(max_mem_address)
        mem = int((max_mem_address_num - 1)/1024.0/1024.0) + 1
        return Result( None, mem)
    except Exception as e:
        return Result( 'Error:' + str(e), None)

def get_system_boot_state():
    if not os.path.isdir("/sys/firmware/efi/"):
        return "Legacy"
    else:
        return "EFI"

# debug
# print get_cpu_nums().getValue()
# print get_mem_capacity().getValue()
# print get_mem_capacity2().getValue()

