#!/bin/python
#-*- coding: utf-8 -*-

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

import os
import subprocess
from basic_lib import *

def get_fastboot_can_use():
    """state if fastboot can use"""
    # if not get_system_boot_state() == "EFI":
    #     return False
    fastboot_deb = "cdos-fastboot"
    fastboot_res = subprocess.Popen([ "dpkg", "-l", fastboot_deb], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    # err = fastboot_res.stderr.read().split("\n")
    out = fastboot_res.stdout.read().split("\n")
    # if cdos-fastboot can use
    if (not out == [""]) and (out[-2].startswith("ii")) and (os.system("bash /usr/share/cdos-fastboot/cdos-fastboot.sh checkforsys") == 0):
        return True
    return False

def get_fastboot_state():
    """state if fastboot on/off"""
    fastboot_config_file = "/etc/cdos-fastboot/cdos-fastboot.conf"
    try:
        state = None
        infos = open(fastboot_config_file).read().split("\n")
        for info in infos:
            if info.startswith("STATE="):
                state = info.split("=")[-1]
        if (state is not None) and (state == "on"):
            return True
        else:
            return False
    except Exception as e:
        return False

def set_fastboot_state(state):
    if state == True:
        os.system("bash /usr/share/cdos-fastboot/cdos-fastboot.sh on")
    if state == False:
        os.system("bash /usr/share/cdos-fastboot/cdos-fastboot.sh off")
    return

def biosinfirmwaresetupblacklist():
    try:
        firmwaresetupblacklist_file = "/usr/share/boot-manager/frontend/blacklist/firmware"
        bios_version = subprocess.check_output( ['dmidecode', '-s', 'bios-version']).split("\n")[0]
        biosblacklist = open( firmwaresetupblacklist_file).read().split("\n")
        if (not bios_version == "") and (bios_version in biosblacklist):
            return True
        return False
    except Exception as e:
        return False

