#!/usr/bin/env python
# -*- coding: UTF-8 -*-

from grub_lib import grub_config

def TEST_get_grub_env_from_file():
    print("-------- TestCase: get_grub_env_from_file() ")
    print("-------- Input: None ")
    print("-------- Expected Outout: grub env dict")
    env_json = grub_config.get_grub_env_from_file()
    if isinstance(env_json, dict):
        print("PASS ------ get_grub_env_from_file \n")
    else:
        print("FAIL ------ get_grub_env_from_file \n")

def TEST_get_kernel_version():
    print("-------- TestCase: get_kernel_version(kernel) ")
    print("-------- Input: vmlinuz-5.4.0-49 ")
    print("-------- Expected Outout: 5.4.0-49 ")
    kernel_version = grub_config.get_kernel_version("vmlinuz-5.4.0-49")
    if kernel_version == "5.4.0-49":
        print("PASS ------ get_kernel_version \n")
    else:
        print("FAIL ------ get_kernel_version \n")

def TEST_get_kernels_from_os():
    print("-------- TestCase: get_kernels_from_os(path=\"/boot/\") ")
    print("-------- Input: None(default /boot/) ")
    print("-------- Expected Outout: not null ")
    kernel_list = grub_config.get_kernels_from_os()
    if kernel_list:
        print("PASS ------ get_kernels_from_os \n")
    else:
        print("FAIL ------ get_kernels_from_os \n")

def TEST_get_os_info_from_cfg():
    print("-------- TestCase: get_os_info_from_cfg() ")
    print("-------- Input: None ")
    print("-------- Expected Outout: info dict ")
    info = grub_config.get_os_info_from_cfg()
    if isinstance(info, dict):
        print("PASS ------ get_os_info_from_cfg \n")
    else:
        print("FAIL ------ get_os_info_from_cfg \n")

if __name__ == '__main__':
    print("TEST start ...\n")
    TEST_get_grub_env_from_file()
    TEST_get_kernel_version()
    TEST_get_kernels_from_os()
    TEST_get_os_info_from_cfg()
    print("TEST end ...")
